"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combineEvents = combineEvents;
var _effector = require("effector");
function combineEvents({
  events,
  reset,
  target = (0, _effector.createEvent)({
    name: "target",
    sid: "aip3nf"
  })
}) {
  if (!(_effector.is.unit(target) && _effector.is.targetable(target))) throwError('target should be a targetable unit');
  if (reset && !_effector.is.unit(reset)) throwError('reset should be a unit');
  (0, _effector.withRegion)(target, () => {
    const keys = Object.keys(events);
    const defaultShape = Array.isArray(events) ? [...keys].fill('') : {};
    const $counter = (0, _effector.createStore)(keys.length, {
      and: {
        serialize: 'ignore'
      },
      name: "$counter",
      sid: "-cuwegw"
    });
    const $results = (0, _effector.createStore)(defaultShape, {
      and: {
        serialize: 'ignore'
      },
      name: "$results",
      sid: "cn2cpl"
    });
    $counter.reset((0, _effector.sample)({
      and: [{
        source: target
      }],
      or: {
        sid: "-80w3us"
      }
    }));
    $results.reset(target);
    if (reset) {
      $counter.reset((0, _effector.sample)({
        and: [{
          source: reset
        }],
        or: {
          sid: "3t8gjw"
        }
      }));
      $results.reset(reset);
    }
    for (const key of keys) {
      const $isDone = (0, _effector.createStore)(false, {
        and: {
          serialize: 'ignore'
        },
        name: "$isDone",
        sid: "vavgfq"
      }).on(events[key], () => true).reset(target);
      if (reset) {
        $isDone.reset(reset);
      }
      $counter.on($isDone, value => value - 1);
      $results.on(events[key], (shape, payload) => {
        const newShape = Array.isArray(shape) ? [...shape] : {
          ...shape
        };
        newShape[key] = payload;
        return newShape;
      });
    }
    const eventsTrriggered = (0, _effector.sample)({
      and: [{
        source: $results,
        clock: [...Object.values(events)]
      }],
      or: {
        name: "eventsTrriggered",
        sid: "-o4wcap"
      }
    });
    (0, _effector.sample)({
      and: [{
        source: eventsTrriggered,
        filter: $counter.map(value => value === 0, {
          skipVoid: false
        }),
        target: target
      }],
      or: {
        sid: "cm94rj"
      }
    });
  });
  return target;
}
function throwError(message) {
  throw new Error(message);
}