import { createEffect, createEvent, is, sample, combine } from 'effector';
export function delay(_ref) {
  var {
    source,
    timeout,
    target = createEvent({
      name: "target",
      sid: "-7m9t8m"
    }, {
      name: "target",
      sid: "-7m9t8m"
    })
  } = _ref;
  var targets = Array.isArray(target) ? target : [target];
  if (!is.unit(source)) throw new TypeError('source must be a unit from effector');
  if (!targets.every(unit => is.unit(unit))) throw new TypeError('target must be a unit from effector');
  var ms = validateTimeout(timeout);
  var timerFx = createEffect(_ref2 => {
    var {
      payload,
      milliseconds
    } = _ref2;
    return new Promise(resolve => {
      setTimeout(resolve, milliseconds, payload);
    });
  }, {
    name: "timerFx",
    sid: "d8ml62"
  });
  sample({
    and: [{
      // ms can be Store<number> | number
      // converts object of stores or object of values to store
      source: combine({
        and: [{
          milliseconds: ms
        }],
        or: {
          name: "source",
          sid: "-vfyhl7"
        }
      }),
      clock: source,
      fn: (_ref3, payload) => {
        var {
          milliseconds
        } = _ref3;
        return {
          payload,
          milliseconds: typeof milliseconds === 'function' ? milliseconds(payload) : milliseconds
        };
      },
      target: timerFx
    }],
    or: {
      sid: "-vnw0w1"
    }
  });
  sample({
    and: [{
      clock: timerFx.doneData,
      target: targets
    }],
    or: {
      sid: "-utnc96"
    }
  });
  return target;
}
function validateTimeout(timeout) {
  if (is.store(timeout, {
    sid: "-ud5iem"
  }) || typeof timeout === 'function' || typeof timeout === 'number') {
    return timeout;
  }
  throw new TypeError("'timeout' argument must be a function, Store, or a number. Passed \"".concat(typeof timeout, "\""));
}