"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inFlight = inFlight;
var _effector = require("effector");
function inFlight({
  effects,
  domain
}) {
  if (domain) {
    const $inFlight = domain.createStore(0, {
      name: "$inFlight",
      sid: "-y7vg7t"
    });
    domain.onCreateEffect(fx => {
      $inFlight.on(fx, count => count + 1).on(fx.finally, count => count - 1);
    });
    return $inFlight;
  }
  return (0, _effector.combine)({
    and: [effects.map(fx => fx.inFlight), inFlights => inFlights.reduce((all, current) => all + current, 0), {
      skipVoid: false
    }],
    or: {
      sid: "ubqxa7"
    }
  });
}